export default interface Props extends InputComponentTypes {
    // formContext: any
}

interface LabelType {
    text: string,
    position: string
}

interface IconType {
    icon: string,
    position: string
}

interface DropDownType {
    data: any[],
    selected: string | number,
    displayField: string,
    displayValue: string
}

interface SearchType {
    data?: any[],
    remote?: string,
    displayField: string,
    displayValue?: string,
}

export interface InputComponentTypes {
    type: string,
    onChange?: Function,
    onClick?: Function,
    onBlur?: Function,
    onKeyPress?: Function,
    onKeyDown?: Function,
    element?: Function,
    name?: string,
    caption?: string,
    id?: any,
    value?: string,
    validate?: any[],
    errorMessage?: string,
    loading?: boolean,
    label?: string | LabelType[]
    icon?: string | IconType[],
    button?: Function,
    dropdown?: DropDownType,
    debounce?: number,
    autoComplete?: string,
    search?: SearchType,
    disabled?: boolean,
    readOnly?: boolean,
    readOnlyInput?: boolean,
    autoFocus?: boolean,
    maxLength?: number,
    mask?: string,
    placeholder?: string,
    size?: string,
    customStyle?: string,
    passwordView?: boolean,
    spellCheck?: boolean,
    infoText?: string,
    noBorder?: boolean,
    noRadius?: boolean,
    rounded?: boolean,
    color?: string,
    customRender?:any,
    inputDropdown?:any
}
