import React, {Component} from 'react';
import Icon from './Icon'
import {isEmpty, isString, isArray} from 'lodash'
// import t from './language';

export default class RenderHtml extends Component {

    static renderError(errorMessage) {
        return errorMessage && !isEmpty(errorMessage) ? <div className="krax-help is-danger">{errorMessage}</div> : null
    }

    static renderButton(button, size) {
        if (button) {
            return button()
        }
        return null
    }


    static renderLoading(loading) {
        if (loading) {
            return <div className="icon-ui loading"><Icon icon="fal fa-spinner-third" spin/></div>
        }

        return null
    }

    /*static renderLabel(label, position) {

        if (label && !isEmpty(label)) {

            if (isString(label) && position === 'left') {
                return <div className="label-ui">{label}</div>
            }

            const x = isObject(label) ? label.filter(item => item.position === position) : [];
            if (x.length ) {
                return x.map((item,i) => {
                    if (item.position === position) {
                        return <div className={`label-ui ${position === 'right' ? 'right' : ''}`} key={i}>{item.text}</div>
                    }
                })
            }
            return null
        }

        return null
    }*/

    /*static renderIcon(icon, position) {

        if (icon && !isEmpty(icon)) {
            if (isString(icon) && position === 'left') {
                return <div className="icon-ui"><Icon icon={icon} /></div>
            }

            const x = isObject(icon) ? icon.filter(item => item.position === position) : [];
            if (x.length ) {
                return x.map((item,i) => {
                    if (item.position === position) {
                        return <div className="icon-ui" key={i}><Icon icon={item.icon} /></div>
                    }
                })
            }

            return null
        }

        return null
    }*/

    static renderIcon(icon, position, size) {

        if (icon && !isEmpty(icon)) {
            if (isString(icon) && position === 'left') {
                return <span className={`krax-icon is-${position}`}>
                          <Icon icon={icon} />
                        </span>
            }

            const x = isArray(icon) && icon.length ? icon.filter(item => item.position === position) : [];

            if (x.length ) {
                return x.map((item,i) => {
                    if (item.position === position) {
                        return <span className={`krax-icon is-${position}`} key={i}>
                          <Icon icon={item.icon} />
                        </span>
                    }
                })
            }

            return null
        }

        return null
    }

    static renderLabel(icon, position, size) {
        if (icon && !isEmpty(icon)) {
            if (isString(icon) && position === 'left') {
                return <p className="krax-control">
                    <a className={`krax-button is-static ${size}`}>
                        {icon}
                    </a>
                </p>
            }

            const x = isArray(icon) ? icon.filter(item => item.position === position) : [];
            if (x.length ) {
                return x.map((item,i) => {
                    if (item.position === position) {
                        return <p className="krax-control" key={i}>
                            <a className={`krax-button is-static ${size}`}>
                                {item.text}
                            </a>
                        </p>
                    }
                })
            }

            return null
        }

        return null
    }

}
